// default prefs if we cant read the prefs
var linky_pref_showselect = 30;
var linky_pref_showopen = 2;
var linky_pref_imgexts = "jpg|jpeg|gif|png|bmp";

// support functions
function getSelectionString() {
	var focusedWindow = document.commandDispatcher.focusedWindow;
	var selection = focusedWindow.__proto__.getSelection.call(focusedWindow);
	return String(selection);
}
function getSelectionObject() {
	var focusedWindow = document.commandDispatcher.focusedWindow;
	return focusedWindow.__proto__.getSelection.call(focusedWindow);
}
function linkySafe(lnk) {
	if (!lnk) {
		return false;
	} else {
		lnk = lnk.toLowerCase();
		if (lnk.substr(0,7) == "mailto:" || lnk.substr(0,11) == "javascript:") {
			return false;
		} else {
			return true;
		}
	}
}
function imageURL(u) {
	var linky_imageurl = new RegExp("\." + linky_pref_imgexts + "$", "i");
	if (!u) {
		return false;
	} else {
		if (linky_imageurl.test(u)) {
			return true;
		} else {
			return false;
		}
	}
}
function linkyContextStuff(p, ele) {
	if (!p) {
		// yes all of them
		for (var i=0; i<ele.length; i++) {
			document.getElementById(ele[i]).setAttribute("hidden", true);
		}
		return false;
	} else {
		// perhaps some of them
		for (i=0; i<ele.length; i++) {
			if (((i == 1 || i == 3) && linky_pref_showopen == 1) || ((i == 2 || i == 4) && linky_pref_showopen == 0)) {
				document.getElementById(ele[i]).setAttribute("hidden", true);
			} else {
				document.getElementById(ele[i]).setAttribute("hidden", false);
			}
		}
		return true;
	}
}
function linkyPref() {
	// have to use try catch since Phoenix dont support goPreferences
	try {
		goPreferences('linky-pref-panel', 'chrome://linky/content/linky-pref-panel.xul', 'linky-pref-panel');
	} catch(err) {
		openPreferences();
	}
}
function openLink(lnk, typ, doc) {
	if (typ == 1) {
		var browser;
		try {
			browser = getBrowser();
		} catch (ex if ex instanceof ReferenceError) {
			var windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
			var browserWin = windowMediator.getMostRecentWindow("navigator:browser");
			if (!browserWin) {
				window.openDialog(getBrowserURL(), "_blank", "chrome,all,dialog=no", lnk, null, getReferrer(document));
				return;
			} else {
				browser = browserWin.getBrowser();
			}
		}
		try {
			browser.addTab(lnk, getReferrer(document));
		} catch(err) {
			trace("Unable to open " + lnk, 1, err);
		}
	} else if (typ == 2) {
		try {
			document.commandDispatcher.focusedWindow.open(lnk);
		} catch(err) {
			trace("Unable to open " + lnk, 1, err);
		}
	} else if (typ == 3) {
		if (!doc) {
			trace("Document is undefined", 1);
		} else {
			doc.writeln('<img src="' + lnk + '" alt="' + lnk + '" title="' + lnk + '">');
		}
	} else {
		trace("openLink called with unknown typ:" + typ, 1);
	}
}

// enables and disables the context menu items
// p indicates where where the context menu was called:
//   0 or not indicated : Mozilla normal context menu
//   1 : From the Mozilla Firebird/Phoenix Go context menu
//   2 : From the Mozilla Mail context menu
function linkyContext(p) {
	// context menuitems
	var elementTagsSelected;
	if (p == 1)
		elementTagsSelected = new Array('linky-selected-sep-go', 'linky-selected-tab-go', 'linky-selected-win-go');
	else if (p == 2)
		elementTagsSelected = new Array('linky-selected-sep-mail', 'linky-selected-tab-mail', 'linky-selected-win-mail');
	else
		elementTagsSelected = new Array('linky-selected-sep', 'linky-selected-tab', 'linky-selected-win');

	var elementTagsSelectedLink;
	if (p == 1)
		elementTagsSelectedLink = new Array('linky-selected-text-sep-go', 'linky-selected-text-tab-go', 'linky-selected-text-win-go');
	else if (p == 2)
		elementTagsSelectedLink = new Array('linky-selected-text-sep-mail', 'linky-selected-text-tab-mail', 'linky-selected-text-win-mail');
	else
		elementTagsSelectedLink = new Array('linky-selected-text-sep', 'linky-selected-text-tab', 'linky-selected-text-win');

	var elementTagsAll;
	if (p == 1)
		elementTagsAll = new Array('linky-all-sep-go', 'linky-all-tab-go', 'linky-all-win-go');
	else if (p == 2)
		elementTagsAll = new Array('linky-all-sep-mail', 'linky-all-tab-mail', 'linky-all-win-mail');
	else
		elementTagsAll = new Array('linky-all-sep', 'linky-all-tab', 'linky-all-win');

	var elementTagsPictureAll;
	if (p == 1)
		elementTagsPictureAll = new Array('linky-pictures-sep-go', 'linky-pictures-tab-go', 'linky-pictures-win-go');
	else if (p == 2)
		elementTagsPictureAll = new Array('linky-pictures-sep-mail', 'linky-pictures-tab-mail', 'linky-pictures-win-mail');
	else
		elementTagsPictureAll = new Array('linky-pictures-sep', 'linky-pictures-tab', 'linky-pictures-win');

	var elementTagsPictureLinks;
	if (p == 1)
		elementTagsPictureLinks = new Array('linky-pictures-links-page-sep-go', 'linky-pictures-links-page-tab-go', 'linky-pictures-links-page-win-go');
	else if (p == 2)
		elementTagsPictureLinks = new Array('linky-pictures-links-page-sep-mail', 'linky-pictures-links-page-tab-mail', 'linky-pictures-links-page-win-mail');
	else
		elementTagsPictureLinks = new Array('linky-pictures-links-page-sep', 'linky-pictures-links-page-tab', 'linky-pictures-links-page-win');

	var elementTagsPicturePage;
	if (p == 1)
		elementTagsPicturePage = new Array('linky-pictures-page-sep-go', 'linky-pictures-page-tab-go', 'linky-pictures-page-win-go');
	else if (p == 2)
		elementTagsPicturePage = new Array('linky-pictures-page-sep-mail', 'linky-pictures-page-tab-mail', 'linky-pictures-page-win-mail');
	else
		elementTagsPicturePage = new Array('linky-pictures-page-sep', 'linky-pictures-page-tab', 'linky-pictures-page-win');
	
	var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
	var pref = prefService.getBranch(null);

	try {
		linky_pref_showselect = pref.getIntPref("extensions.linky.showselect");
	} catch(err) {
		trace("Unable to read the pref extensions.linky.showselect", 0, err);
	}
	try {
		linky_pref_showopen = pref.getIntPref("extensions.linky.showopen");
	} catch(err) {
		trace("Unable to read the pref extensions.linky.showopen", 0, err);
	}
	try {
		linky_pref_imgexts = pref.getCharPref("extensions.linky.imgexts");
	} catch(err) {
		trace("Unable to read the pref extensions.linky.imgexts", 0, err);
	}

	try {
		if (!linkyContextStuff(pref.getBoolPref("extensions.linky.context.selectedlinks"), elementTagsSelected)) {
			elementTagsSelected = false;
		}
	} catch(err) {
		trace("Unable to read the pref extensions.linky.context.selectedlinks", 0, err);
	}
		
	try {
		if (!linkyContextStuff(pref.getBoolPref("extensions.linky.context.selectedtextlinks"), elementTagsSelectedLink)) {
			elementTagsSelectedLink = false;
		}
	} catch(err) {
		trace("Unable to read the pref extensions.linky.context.selectedtextlinks", 0, err);
	}
	try {
		if (!linkyContextStuff(pref.getBoolPref("extensions.linky.context.alllinks"), elementTagsAll)) {
			elementTagsAll = false;
		}
	} catch(err) {
		trace("Unable to read the pref extensions.linky.context.alllinks", 0, err);
	}
	try {
		if (!linkyContextStuff(pref.getBoolPref("extensions.linky.context.piclinks"), elementTagsPictureAll)) {
			elementTagsPictureAll = false;
		}
	} catch(err) {
		trace("Unable to read the pref extensions.linky.context.piclinks", 0, err);
	}
	try {
		if (!linkyContextStuff(pref.getBoolPref("extensions.linky.context.piclinksshow"), elementTagsPictureLinks)) {
			elementTagsPictureLinks = false;
		}
	} catch(err) {
		trace("Unable to read the pref extensions.linky.context.piclinksshow", 0, err);
	}
	try {
		if (!linkyContextStuff(pref.getBoolPref("extensions.linky.context.picshow"), elementTagsPicturePage)) {
			elementTagsPicturePage = false;
		}
	} catch(err) {
		trace("Unable to read the pref extensions.linky.context.piclinksshow", 0, err);
	}

	var disabled = true;

	// check for selection
	if (elementTagsSelected) {
		if (getSelectionString().length > 0) {
			if ("links" in document.commandDispatcher.focusedWindow.document) {
				if (document.commandDispatcher.focusedWindow.document.links.length != 0) {
					disabled = false;
				}
			} else {
				trace("Fallback: Unable to get links in document");
				disabled = false;
			}
		}
		for (var i=0; i<elementTagsSelected.length; i++) {
			document.getElementById(elementTagsSelected[i]).setAttribute("disabled", disabled);
		}
	}

	// check for links in selection
	if (elementTagsSelectedLink) {
		disabled = true;
		if (getSelectionString().length > 0) {
			var selection = getSelectionObject();
			var URL=/(\w*:\/\/)?\S+\.(com|edu|org|net|dk)(\/)?(\S+)?/gm;
			var lnks = URL.exec(selection);
			if (lnks) {
				disabled = false;
			}
		}
		for (i=0; i<elementTagsSelectedLink.length; i++) {
			document.getElementById(elementTagsSelectedLink[i]).setAttribute("disabled",disabled);
		}
	}

	// check for links
	if (elementTagsAll) {
		disabled = false;
		if ("links" in document.commandDispatcher.focusedWindow.document && document.commandDispatcher.focusedWindow.document.links.length < 1) {
			disabled = true;
		}
		for (i=0; i<elementTagsAll.length; i++) {
			document.getElementById(elementTagsAll[i]).setAttribute("disabled",disabled);
		}
	}

	// check for picture links
	if (elementTagsPictureAll || elementTagsPictureLinks) {
		disabled = false;
		if ("links" in document.commandDispatcher.focusedWindow.document) {
			// update the info item with current numbers of links and images
			var msg = document.getElementById("bundle_linky").getString("linky-info");
			msg = replaceInsert(msg, 1, document.commandDispatcher.focusedWindow.document.links.length);
			if ("images" in document.commandDispatcher.focusedWindow.document) {
				msg = replaceInsert(msg, 2, document.commandDispatcher.focusedWindow.document.images.length);
			} else {
				msg = replaceInsert(msg, 1, 0);
			}
			if (p == 1)
				document.getElementById("linky-info-go").label = msg;
			else if (p == 2)
				document.getElementById("linky-info-mail").label = msg;
			else
				document.getElementById("linky-info").label = msg;
	
			// check for picture links
			if (document.commandDispatcher.focusedWindow.document.links.length != 0) {
				// because of performance only check the first 100 links
				if (document.commandDispatcher.focusedWindow.document.links.length > 100) {
					disabled = false;
					trace("More than 100 links. There's " + document.commandDispatcher.focusedWindow.document.links.length);
				} else {
					var lnks = document.commandDispatcher.focusedWindow.document.links;
					var badurl=0;
					for (i = 0; i < lnks.length; i++) {
						if (imageURL(lnks[i].href)) {
							badurl=1;
							break;
						}
					}
					if (badurl) {
						disabled = false;
					} else {
						disabled = true;
					}
				}
			} else {
				disabled = true;
			}
		} else {
			if (p == 1)
				document.getElementById("linky-info-go").label=document.getElementById("bundle_linky").getString("linky-info-na");
			else if (p == 2)
				document.getElementById("linky-info-mail").label=document.getElementById("bundle_linky").getString("linky-info-na");
			else
				document.getElementById("linky-info").label=document.getElementById("bundle_linky").getString("linky-info-na");
		}		
		for (i=0; i<elementTagsPictureAll.length; i++) {
			document.getElementById(elementTagsPictureAll[i]).setAttribute("disabled",disabled);
		}
		for (i=0; i<elementTagsPictureLinks.length; i++) {
			document.getElementById(elementTagsPictureLinks[i]).setAttribute("disabled",disabled);
		}
	}

	// check for images on page
	if (elementTagsPicturePage) {
		disabled = false;
		if ("images" in document.commandDispatcher.focusedWindow.document && document.commandDispatcher.focusedWindow.document.images.length < 1) {
			disabled = true;
		}
		for (i=0; i<elementTagsPicturePage.length; i++) {
			document.getElementById(elementTagsPicturePage[i]).setAttribute("disabled",disabled);
		}
	}
}

// open selected links
// opentype: 1 = in new tab, 2 = in new window
function linkySelected(opentype, event) {
	if (getSelectionString().length < 1) {
		trace("Selection is empty!", 1);
	} else {
		// holding down the SHIFT key while pressing the menuitem forces the select links dialog
		var linky_forceselect = false;
		if (event.shiftKey) {
			linky_forceselect = true;
		}
		if ("links" in document.commandDispatcher.focusedWindow.document) {
			var lnks = document.commandDispatcher.focusedWindow.document.links;
			if (lnks.length < 1) {
				trace("No links in selection!", 1);
			} else {
				var urls = new Array();
				var selection = getSelectionObject();
				for (var i = 0; i < lnks.length; ++i) {
					if (selection.containsNode(lnks[i], true)) {
						if (document.commandDispatcher.focusedWindow.document.location != lnks[i].href && linkySafe(lnks[i].href)) {
							// check for dupe URLs
							var badurl = 0;
							for (var j = 0; j < urls.length; j++) {
								if (urls[j] == lnks[i].href || lnks[i] == document.commandDispatcher.focusedWindow.document.location.href) {
									badurl = 1;
									break;
								}
							}
							if (!badurl) {
								urls[urls.length] = lnks[i].href;
							}
						}
					}
				}
				if (urls.length > 0) {
					if (linky_forceselect || urls.length >= linky_pref_showselect) {
						window.openDialog("chrome://linky/content/linkySelect.xul","_blank","chrome,modal,centerscreen,resizable=yes", urls, opentype);
					} else {
						for (i = 0; i < urls.length; i++) {
							openLink(urls[i], opentype);
						}
					}
				} else {
					trace("No links in selection!", 1);
				}
			}
		} else {
			trace("Cant access links in document!", 1);
		}
	}
}

// open selected text links
// opentype: 1 = in new tab, 2 = in new window
function linkySelectedText(opentype, event) {
	if (getSelectionString().length < 1) {
		trace("Selection is empty!", 1);
	} else {
		// holding down the SHIFT key while pressing the menuitem forces the select links dialog
		var linky_forceselect = false;
		if (event.shiftKey) {
			linky_forceselect = true;
		}
		var selection = getSelectionObject();
		var urls = new Array();
		var URL=/(\w*:\/\/)?\S+\.(com|edu|org|net|dk)(\/)?(\S+)?/gm;
		var lnks = URL.exec(selection);
		while (lnks) {
			if (!lnks[1]) {
				lnks[0] = "http://" + lnks[0];
			}
			if (!lnks[3]) {
				lnks[0] += "/";
			}
			if (linkySafe(lnks[0]) && lnks[0] != document.commandDispatcher.focusedWindow.document.location.href) {
				// check for dupe urls
				var badurl = 0;
				for (var j = 0; j < urls.length; j++) {
					if (urls[j] == lnks[0]) {
						badurl = 1;
						break;
					}
				}
				if (!badurl) {
					urls[urls.length] = lnks[0];
				}
			}
			// procede to the next link
			lnks = URL.exec(selection);
		}
		if (urls.length > 0) {
			if (linky_forceselect || urls.length >= linky_pref_showselect) {
				window.openDialog("chrome://linky/content/linkySelect.xul","_blank","chrome,modal,centerscreen,resizable=yes", urls, opentype);
			} else {
				for (var i = 0; i < urls.length; i++) {
					openLink(urls[i], opentype);
				}
			}
		} else {
			trace("No links in selection!", 1);
		}
	}
}

// Show all images
// opentype: 3 = in one new tab, 4 = in one new window
function linkyImages(opentype, event) {
	if ("images" in document.commandDispatcher.focusedWindow.document) {
		// holding down the SHIFT key while pressing the menuitem forces the select links dialog
		var linky_forceselect = 0;
		if (event.shiftKey) {
			linky_forceselect = 1;
		}
		var imgs = document.commandDispatcher.focusedWindow.document.images;
		var urls = new Array();
		for (var i = 0; i < imgs.length; i++) {
			if (imgs[i].src) {
				var badurl = 0;
				for (var j = 0; j < urls.length; j++) {
					if (urls[j] == imgs[i].src) {
						badurl = 1;
						break;
					}
				}
				if (!badurl) {
					urls[urls.length] = imgs[i].src;
				}
			}
		}
		if (urls.length > 0) {
			if (linky_forceselect || urls.length >= linky_pref_showselect) {
				window.openDialog("chrome://linky/content/linkySelect.xul","_blank","chrome,modal,centerscreen,resizable=yes", urls, opentype + 2);
			} else {
				var doc;
				if (opentype == 3) {
					try {
						var tmp = gBrowser.getBrowserForTab(gBrowser.addTab("about:blank"));
						doc = tmp.contentDocument;
					} catch(err) {
						trace("Unable to add new tab", 1, err);
					}
				} else if (opentype == 4) {
					try {
						doc = document.commandDispatcher.focusedWindow.open("about:blank").document;
					} catch(err) {
						trace("Unable to add new window", 1, err);
					}
				} else {
					trace("Unknown opentype: " + opentype, 1);
				}
				for (i = 0; i < urls.length; i++) {
					openLink(urls[i], 3, doc);
				}
				// have to close document to actual see the page
				doc.close();
			}
		} else {
			trace("No images detected!", 1);
		}
	} else {
		trace("Cant access images in document!", 1);
	}
}

// Open all links
// opentype: 1 = in new tab, 2 = in new window
function linkyAll(opentype, event) {
	if ("links" in document.commandDispatcher.focusedWindow.document) {
		// holding down the SHIFT key while pressing the menuitem forces the select links dialog
		var linky_forceselect = 0;
		if (event.shiftKey) {
			linky_forceselect = 1;
		}
		var lnks = document.commandDispatcher.focusedWindow.document.links;

		var urls = new Array();
		for (var i = 0; i < lnks.length; i++) {
			if (linkySafe(lnks[i].href)) {
				var badurl = 0;
				for (var j = 0; j < urls.length; j++) {
					if (urls[j] == lnks[i].href || lnks[i] == document.commandDispatcher.focusedWindow.document.location.href) {
						badurl = 1;
						break;
					}
				}
				if (!badurl) {
					urls[urls.length] = lnks[i].href;
				}
			}
		}
		if (urls.length > 0) {
			if (linky_forceselect || urls.length >= linky_pref_showselect) {
				window.openDialog("chrome://linky/content/linkySelect.xul","_blank","chrome,modal,centerscreen,resizable=yes", urls, opentype);
			} else {
				for (i = 0; i < urls.length; i++) {
					openLink(urls[i], opentype);
				}
			}
		} else {
			trace("No links in selection!", 1);
		}
	} else {
		trace("Cant access links in document!", 1);
	}
}

// Show all image links on one page
// opentype: 1 = in new tab, 2 = in new window, 3 = in one new tab, 4 = in one new window
function linkyAllPics(opentype, event) {
	if ("links" in document.commandDispatcher.focusedWindow.document) {
		// holding down the SHIFT key while pressing the menuitem forces the select links dialog
		var linky_forceselect = 0;
		if (event.shiftKey) {
			linky_forceselect = 1;
		}
		var lnks = document.commandDispatcher.focusedWindow.document.links;
		var urls = new Array();
		for (var i = 0; i < lnks.length; i++) {
			if (imageURL(lnks[i].href)) {
				var badurl = 0;
				for (var j = 0; j < urls.length; j++) {
					if (urls[j] == lnks[i].href) {
						badurl = 1;
						break;
					}
				}
				if (!badurl) {
					urls[urls.length] = lnks[i].href;
				}
			}
		}
		if (urls.length > 0) {
			if (linky_forceselect || urls.length >= linky_pref_showselect) {
				window.openDialog("chrome://linky/content/linkySelect.xul","_blank","chrome,modal,centerscreen,resizable=yes", urls, opentype);
			} else {
				if (opentype < 3) {
					for (i = 0; i < urls.length; i++) {
						openLink(urls[i], opentype);
					}
				} else {
					var doc;
					if (opentype == 3) {
						try {
							var tmp = gBrowser.getBrowserForTab(gBrowser.addTab("about:blank"));
							doc = tmp.contentDocument;
						} catch(err) {
							trace("Unable to add new tab", 1, err);
						}
					} else if (opentype == 4) {
						try {
							doc = document.commandDispatcher.focusedWindow.open("about:blank").document;
						} catch(err) {
							trace("Unable to add new window", 1, err);
						}
					} else {
						trace("Unknown opentype: " + opentype);
					}
					for (i = 0; i < urls.length; i++) {
						openLink(urls[i], 3, doc);
					}
					// have to close document to actual see the page
					doc.close();
				}
			}
		} else {
			trace("No links detected!", 1);
		}
	} else {
		trace("Cant access links in document!", 1);
	}
}
